import 'package:flutter/material.dart';
import 'package:get/get.dart';

import '../yao_core.dart';
import 'manager/middleware.dart';
import 'mixin/app.dart';
import 'widget/error_retrier.dart';

abstract class YaoService<T> extends GetxService with AppMixin {
  Future<T> run();
}

class YaoView<T> extends StatelessWidget {
  const YaoView({Key? key}) : super(key: key);

  final String? tag = null;

  T get c => GetInstance().find<YaoController>(tag: tag) as T;

  Request get request => GetInstance().find<Request>();

  @override
  Widget build(BuildContext context) {
    throw UnimplementedError();
  }

  Widget withState(BuildContext context, {required Widget child}) {
    YaoControllerWithState tmp = c as YaoControllerWithState;
    return tmp.obx((state) => child,
        onLoading: Builder(
          builder: (BuildContext context) {
            return Center(child: CircularProgressIndicator());
          },
        ),
        onError: (err) => MaterialApp(
            debugShowCheckedModeBanner: false,
            home: Scaffold(
                body: SafeArea(
                    child: (ErrorRetrier(err == null ? "" : err, () async {
              final app = Yao();
              app.redirect(request.route);
            }))))));
  }
}

abstract class YaoController extends GetxController with AppMixin {}

abstract class YaoControllerWithState<T> extends YaoController
    with StateMixin<T> {}
